#include "tub_signal.h"

static unsigned char const *tub_post_mmap_lo, *tub_post_mmap_hi;

int
handler(int signum, siginfo_t const *info, ucontext_t *uc)
{
	unsigned char const *pc = (unsigned char const *)uc->uc_mcontext.eip;
	unsigned long *p = &uc->uc_mcontext.edi;
	int j;

	if (SIGBUS!=signum) {
		return *(unsigned char *)0;
	}
	if (SIGBUS!=info->si_signo) {
		return *(unsigned char *)1;
	}
	if (0!=(0xff0 & (int)info->si_addr)) {
		return *(unsigned char *)2;
	}
	if (pc < tub_post_mmap_lo
	||  pc >=tub_post_mmap_hi ) {
		return *(unsigned char *)3;
	}
	if (0x80!=pc[0] || 0070!=(~7 & pc[1])  /* cmpb $...,(reg) */
	||  0xb8!=pc[2] ) {
		return *(unsigned char *)4;
	}
	for (j=8; --j>=0; ++p) {
		if (*p==(unsigned long)info->si_addr) {
			*p+= 0x1000;
		}
	}
	uc->uc_mcontext.eip = (unsigned long)tub_post_mmap_hi;
}

int
setup_sigbus_handler(struct sigaction *oldact, void const *pc_lo, void const *pc_hi)
{
	struct sigaction newact;

	tub_post_mmap_lo = pc_lo;
	tub_post_mmap_hi = pc_hi;
	memset(&newact, 0, sizeof(newact));
	newact.sa_handler = handler;
	newact.sa_flags = /*SA_ONESHOT |*/ SA_SIGINFO;
	return rt_sigaction(SIGBUS, &newact, oldact, sizeof(sigset_t));
}

int
unset_sigbus_handler(struct sigaction *oldact)
{
	return rt_sigaction(SIGBUS, oldact, 0, sizeof(sigset_t));
}


